const Master = require("./../../models/app/masterModel");
const User = require("./../../models/app/userModel");
const { check, validationResult, matchedData, oneOf, body } = require('express-validator');
const https = require('https');
var path = require("path");
var db = require('../../config/db');
var moment = require('moment');



exports.getPostalDetailByPincode = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getPostalDetailByPincode = [];
        getPostalDetailByPincode =  await Master.getPostalDetailByPincode(req.body);
        // console.log('getPostalDetailByPincode',getPostalDetailByPincode);
        
        res.status(200).json({
            message: "Postal Master detail by pincode",
            status: "success",
            result : {
                data: getPostalDetailByPincode
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getPostalStateList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getPostalStateList = [];
        getPostalStateList =  await Master.getPostalStateList(req.body);
        // console.log('getPostalStateList',getPostalStateList);
        
        res.status(200).json({
            message: "Postal Master state list",
            status: "success",
            result : {
                data: getPostalStateList
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getPostalDistrictList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getPostalDistrictList = [];
        getPostalDistrictList =  await Master.getPostalDistrictList(req.body);
        // console.log('getPostalDistrictList',getPostalDistrictList);
        
        res.status(200).json({
            message: "Postal Master district list",
            status: "success",
            result : {
                data: getPostalDistrictList
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getPostalCityList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getPostalCityList = [];
        getPostalCityList =  await Master.getPostalCityList(req.body);
        // console.log('getPostalCityList',getPostalCityList);
        
        res.status(200).json({
            message: "Postal Master city list",
            status: "success",
            result : {
                data: getPostalCityList
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getPostalAreaList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getPostalAreaList = [];
        getPostalAreaList =  await Master.getPostalAreaList(req.body);
        // console.log('getPostalAreaList',getPostalAreaList);
        
        res.status(200).json({
            message: "Postal Master Area list",
            status: "success",
            result : {
                data: getPostalAreaList
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getBranchList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getBranchList = [];
        getBranchList =  await Master.getBranchList(req.body);
        // console.log('getBranchList',getBranchList);
        
        res.status(200).json({
            message: "Branch list",
            status: "success",
            result : {
                data: getBranchList
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};

exports.getDistributorNetworkList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        var getDistributorNetworkCount = await Master.getDistributorNetworkCount(req.body)
        
        var getDistributorNetworkList = [];
        if(getDistributorNetworkCount > 0){
            getDistributorNetworkList =  await Master.getDistributorNetworkList(req.body);
            // console.log('getDistributorNetworkList',getDistributorNetworkList);
        }
        
        res.status(200).json({
            message: "Network List",
            status: "success",
            result : {
                data: getDistributorNetworkList,
                count : getDistributorNetworkCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getSalesNetworkList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        var getSalesNetworkCount = await Master.getSalesNetworkCount(req.body)
        
        var getSalesNetworkList = [];
        if(getSalesNetworkCount > 0){
            getSalesNetworkList =  await Master.getSalesNetworkList(req.body);
            // console.log('getSalesNetworkList',getSalesNetworkList);
        }
        
        res.status(200).json({
            message: "Sales Network List",
            status: "success",
            result : {
                data: getSalesNetworkList,
                count : getSalesNetworkCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getChatListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        // var getChatListCount =  await Master.getChatListCount(req.body);
        // console.log('getChatListCount',getChatListCount);
        var getChatListData = [];
        // if(getChatListCount > 0){
        getChatListData =  await Master.getChatListData(req.body);
        // console.log('getChatListData',getChatListData);
        // }
        
        res.status(200).json({
            message: "Chat List Data",
            status: "success",
            result : {
                data: getChatListData,
                // count : getChatListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.sendChatMessage = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        console.log('body ==>', req.body);
        
        var sendChatMessage = await Master.sendChatMessage(req.body);
        console.log('sendChatMessage',sendChatMessage);
        
        if(sendChatMessage.insertId){
            await db.commit();
            res.status(200).json({
                message: "Chat message sent",
                status: "success"
            });
        }else{
            await db.rollback();
            res.status(200).json({
                message: "Chat message sent",
                status: "error"
            });
        }
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getSiteListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getSiteListCount =  await Master.getSiteListCount(req.body);
        console.log('getSiteListCount',getSiteListCount);
        var getSiteListData = [];
        if(getSiteListCount > 0){
            getSiteListData =  await Master.getSiteListData(req.body);
            // console.log('getSiteListData',getSiteListData);
        }
        
        res.status(200).json({
            message: "Site List Data",
            status: "success",
            result : {
                data: getSiteListData,
                count : getSiteListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.getSiteDetailData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        req.body.image_app_path = res.locals.image_app_path;
        
        var getSiteDetailData =  await Master.getSiteDetail(req.body);
        
        res.status(200).json({
            message: "Site Detail Data",
            status: "success",
            result : {
                data: getSiteDetailData,
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.addSiteData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        console.log('body ==>', req.body);
        
        var addSiteData = await Master.addSiteData(req.body);
        console.log('addSiteData',addSiteData);
        
        if(addSiteData.insertId){
            
            if(req.body.siteImage.length){
                var i = req.body.siteImage.length - 1;
                req.body.siteImage.forEach(async element => {
                    element.site_id = addSiteData.insertId ? addSiteData.insertId : 0;
                    element.customer_id = req.body.sfa_app_user_id ? req.body.sfa_app_user_id : 0;
                    var addSiteDataImages = await Master.addSiteDataImages(element);
                    console.log('addSiteDataImages',addSiteDataImages);
                    
                    if(i == 0){
                        await db.commit();
                        res.status(200).json({
                            message: "Site Data Added",
                            status: "success"
                        });
                    }
                    i--;
                });
            }else{
                await db.commit();
                res.status(200).json({
                    message: "Site Data Added",
                    status: "success"
                });
            }
            
        }else{
            await db.rollback();
            res.status(200).json({
                message: "Site Data Added",
                status: "error"
            });
        }
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getContentData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        var  getContentData =  await Master.getContentData(req.body);
        // console.log('getContentData',getContentData);
        
        res.status(200).json({
            message: "Get Content Data",
            status: "success",
            result : {
                data: getContentData,
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getVideoListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        req.body.type = 'video';
        var getMasterContentDataCount =  await Master.getMasterContentDataCount(req.body);
        console.log('getMasterContentDataCount',getMasterContentDataCount);
        var getMasterContentData = [];
        if(getMasterContentDataCount > 0){
            getMasterContentData =  await Master.getMasterContentData(req.body);
            // console.log('getMasterContentData',getMasterContentData);
        }
        
        res.status(200).json({
            message: "Video List Data",
            status: "success",
            result : {
                data: getMasterContentData,
                count : getMasterContentDataCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getFaqListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.type = 'faq';
        req.body.image_app_path = res.locals.image_app_path;
        var getMasterContentDataCount =  await Master.getMasterContentDataCount(req.body);
        console.log('getMasterContentDataCount',getMasterContentDataCount);
        var getMasterContentData = [];
        if(getMasterContentDataCount > 0){
            getMasterContentData =  await Master.getMasterContentData(req.body);
            // console.log('getMasterContentData',getMasterContentData);
        }
        
        res.status(200).json({
            message: "FAQs List Data",
            status: "success",
            result : {
                data: getMasterContentData,
                count : getMasterContentDataCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getNewsListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        req.body.type = 'news';
        var getMasterContentDataCount =  await Master.getMasterContentDataCount(req.body);
        console.log('getMasterContentDataCount',getMasterContentDataCount);
        var getMasterContentData = [];
        if(getMasterContentDataCount > 0){
            getMasterContentData =  await Master.getMasterContentData(req.body);
            // console.log('getMasterContentData',getMasterContentData);
        }
        
        res.status(200).json({
            message: "News List Data",
            status: "success",
            result : {
                data: getMasterContentData,
                count : getMasterContentDataCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getProjectListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProjectListCount =  await Master.getProjectListCount(req.body);
        console.log('getProjectListCount',getProjectListCount);
        var getProjectListData = [];
        if(getProjectListCount > 0){
            getProjectListData =  await Master.getProjectListData(req.body);
            // console.log('getProjectListData',getProjectListData);
        }
        
        res.status(200).json({
            message: "Project List Data",
            status: "success",
            result : {
                data: getProjectListData,
                count : getProjectListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.addProjectData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        console.log('body ==>', req.body);
        
        var addProjectData = await Master.addProjectData(req.body);
        console.log('addProjectData',addProjectData);
        
        if(addProjectData.insertId){
            
            await db.commit();
            res.status(200).json({
                message: "Project Data Added",
                status: "success"
            });
            
        }else{
            await db.rollback();
            res.status(200).json({
                message: "Project Data Added",
                status: "error"
            });
        }
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};

exports.getProjectDetail = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProjectDetail =  await Master.getProjectDetail(req.body);
        // console.log('getProjectDetail',getProjectDetail);
        
        var getProjectSheetDetail =  await Master.getProjectSheetDetail(req.body);
        // console.log('getProjectSheetDetail',getProjectSheetDetail);
        
        res.status(200).json({
            message: "Project Detail Data",
            status: "success",
            result : {
                data: getProjectDetail,
                sheetDetail : getProjectSheetDetail
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getProductUnitListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProductUnitListCount =  await Master.getProductUnitListCount(req.body);
        console.log('getProductUnitListCount',getProductUnitListCount);
        var getProductUnitListData = [];
        if(getProductUnitListCount > 0){
            getProductUnitListData =  await Master.getProductUnitListData(req.body);
            // console.log('getProductUnitListData',getProductUnitListData);
        }
        
        res.status(200).json({
            message: "Product Unit List Data",
            status: "success",
            result : {
                data: getProductUnitListData,
                count : getProductUnitListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getProductTypeListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProductTypeListCount =  await Master.getProductTypeListCount(req.body);
        console.log('getProductTypeListCount',getProductTypeListCount);
        var getProductTypeListData = [];
        if(getProductTypeListCount > 0){
            getProductTypeListData =  await Master.getProductTypeListData(req.body);
            // console.log('getProductTypeListData',getProductTypeListData);
        }
        
        res.status(200).json({
            message: "Product Type List Data",
            status: "success",
            result : {
                data: getProductTypeListData,
                count : getProductTypeListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getProductCategoryListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProductCategoryListCount =  await Master.getProductCategoryListCount(req.body);
        console.log('getProductCategoryListCount',getProductCategoryListCount);
        var getProductCategoryListData = [];
        if(getProductCategoryListCount > 0){
            getProductCategoryListData =  await Master.getProductCategoryListData(req.body);
            // console.log('getProductCategoryListData',getProductCategoryListData);
        }
        
        res.status(200).json({
            message: "Product Category List Data",
            status: "success",
            result : {
                data: getProductCategoryListData,
                count : getProductCategoryListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getProductGroupListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProductGroupListCount =  await Master.getProductGroupListCount(req.body);
        console.log('getProductGroupListCount',getProductGroupListCount);
        var getProductGroupListData = [];
        if(getProductGroupListCount > 0){
            getProductGroupListData =  await Master.getProductGroupListData(req.body);
            // console.log('getProductGroupListData',getProductGroupListData);
        }
        
        res.status(200).json({
            message: "Product Group List Data",
            status: "success",
            result : {
                data: getProductGroupListData,
                count : getProductGroupListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getProductSizeListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProductSizeListCount =  await Master.getProductSizeListCount(req.body);
        console.log('getProductSizeListCount',getProductSizeListCount);
        var getProductSizeListData = [];
        if(getProductSizeListCount > 0){
            getProductSizeListData =  await Master.getProductSizeListData(req.body);
            // console.log('getProductSizeListData',getProductSizeListData);
        }
        
        res.status(200).json({
            message: "Product Size List Data",
            status: "success",
            result : {
                data: getProductSizeListData,
                count : getProductSizeListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.getProductThicknessListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProductThicknessListCount =  await Master.getProductThicknessListCount(req.body);
        console.log('getProductThicknessListCount',getProductThicknessListCount);
        var getProductThicknessListData = [];
        if(getProductThicknessListCount > 0){
            getProductThicknessListData =  await Master.getProductThicknessListData(req.body);
            // console.log('getProductThicknessListData',getProductThicknessListData);
        }
        
        res.status(200).json({
            message: "Product Thickness List Data",
            status: "success",
            result : {
                data: getProductThicknessListData,
                count : getProductThicknessListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getProductBrandListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProductBrandListCount =  await Master.getProductBrandListCount(req.body);
        console.log('getProductBrandListCount',getProductBrandListCount);
        var getProductBrandListData = [];
        if(getProductBrandListCount > 0){
            getProductBrandListData =  await Master.getProductBrandListData(req.body);
            // console.log('getProductBrandListData',getProductBrandListData);
        }
        
        res.status(200).json({
            message: "Product Brand List Data",
            status: "success",
            result : {
                data: getProductBrandListData,
                count : getProductBrandListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.getProductListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getProductListCount =  await Master.getProductListCount(req.body);
        console.log('getProductListCount',getProductListCount);
        var getProductListData = [];
        if(getProductListCount > 0){
            getProductListData =  await Master.getProductListData(req.body);
            // console.log('getProductListData',getProductListData);
        }
        
        res.status(200).json({
            message: "Product List Data",
            status: "success",
            result : {
                data: getProductListData,
                count : getProductListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.getProductDetail = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        // req.body.product_id = decrypt(req.body.product_id);
        req.body.image_app_path = res.locals.image_app_path;

        var getProductDetail = await Master.getProductDetail(req.body);
       
        
        if(getProductDetail.id != undefined){
            res.status(200).json({
                message: "Product detail",
                status: "success",
                data : {
                    detail : getProductDetail,
                  
                }
            });
        }else{
            res.status(200).json({
                message: "Product detail",
                status: "notfound",
            });
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};

exports.getSheetListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getSheetListCount =  await Master.getSheetListCount(req.body);
        console.log('getSheetListCount',getSheetListCount);
        var getSheetListData = [];
        if(getSheetListCount > 0){
            getSheetListData =  await Master.getSheetListData(req.body);
            // console.log('getSheetListData',getSheetListData);
        }
        
        res.status(200).json({
            message: "Sheet List Data",
            status: "success",
            result : {
                data: getSheetListData,
                count : getSheetListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.addSheetData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        console.log('body ==>', req.body);
        
        var addSheetData = await Master.addSheetData(req.body);
        console.log('addSheetData',addSheetData);
        
        if(addSheetData.insertId){
            
            if(req.body.sheetData.length > 0){
                req.body.sheetData.forEach(async element => {
                    element.sfa_app_user_id = req.body.sfa_app_user_id ? req.body.sfa_app_user_id : 0;
                    element.sfa_app_user_name = req.body.sfa_app_user_name ? req.body.sfa_app_user_name : '';
                    element.project_id = req.body.project_id ? req.body.project_id : '';
                    element.sheet_id = addSheetData.insertId ? addSheetData.insertId : 0;
                    var addSheetDataDetail = await Master.addSheetDataDetail(element);
                    console.log('addSheetData',addSheetDataDetail);
                });
            }
            
            await db.commit();
            res.status(200).json({
                message: "Project Sheet Data Added",
                status: "success"
            });
            
        }else{
            await db.rollback();
            res.status(200).json({
                message: "Project Sheet Data Added",
                status: "error"
            });
        }
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


// offer controller start

exports.getOfferListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getOfferListCount =  await Master.getOfferListCount(req.body);
        // console.log('getOfferListCount',getOfferListCount);
        var getOfferListData = [];
        if(getOfferListCount > 0){
            getOfferListData =  await Master.getOfferListData(req.body);
            // console.log('getOfferListData',getOfferListData);
        }
        
        res.status(200).json({
            message: "Offer List Data",
            status: "success",
            result : {
                data: getOfferListData,
                count : getOfferListCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getOfferDetail = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getOfferDetail =  await Master.getOfferDetail(req.body);
        // console.log('getOfferDetail',getOfferDetail);
        
        var getOfferGiftDataDetail =  await Master.getOfferGiftDataDetail(req.body);
        // console.log('getOfferGiftDataDetail',getOfferGiftDataDetail);

        var getOfferSchemeData =  await Master.getOfferSchemeData(req.body);
        // console.log('getOfferSchemeData',getOfferSchemeData);

        var getWalletPoints = await User.getWalletPoints(req.body);
        // console.log('getWalletPoints',getWalletPoints);

        var getLastBalanceUpdateData = await User.getLastBalanceUpdateData(req.body);
        // console.log('getLastBalanceUpdateData',getLastBalanceUpdateData);
      
        res.status(200).json({
            message: "Offer Detail Data",
            status: "success",
            result : {
                data: getOfferDetail,
                giftData : getOfferGiftDataDetail,
                schemeData : getOfferSchemeData,
                walletPoints : getWalletPoints,
                balanceUpdatedOn : getLastBalanceUpdateData
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.getGiftListData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getGiftListCount =  await Master.getGiftListCount(req.body);
        // console.log('getGiftListCount',getGiftListCount);
        var getGiftListData = [];
        if(getGiftListCount > 0){
            getGiftListData =  await Master.getGiftListData(req.body);
            // console.log('getGiftListData',getGiftListData);
        }
        
        var getWalletPoints = await User.getWalletPoints(req.body);
        // console.log('getWalletPoints',getWalletPoints);

        var getLastBalanceUpdateData = await User.getLastBalanceUpdateData(req.body);
        // console.log('getLastBalanceUpdateData',getLastBalanceUpdateData);
        


        res.status(200).json({
            message: "Gift List Data",
            status: "success",
            result : {
                data: getGiftListData,
                count : getGiftListCount,
                walletPoints : getWalletPoints,
                walletLastUpdated : getLastBalanceUpdateData
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.getGiftDetail = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getGiftDetail =  await Master.getGiftDetail(req.body);
        
        var getWalletPoints = await User.getWalletPoints(req.body);
        // console.log('getWalletPoints',getWalletPoints);

        var getLastBalanceUpdateData = await User.getLastBalanceUpdateData(req.body);
        // console.log('getLastBalanceUpdateData',getLastBalanceUpdateData);
        
        res.status(200).json({
            message: "Gift List Detail",
            status: "success",
            result : {
                data: getGiftDetail,
                walletPoints : getWalletPoints,
                balanceUpdatedOn : getLastBalanceUpdateData
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.sendReedemRequest = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        
        var checkOtpRequest = await User.checkOtpRequest(req.body);
        console.log('registerCheckOtpRequest_Temp',checkOtpRequest);
        console.log('registerCheckOtpRequest_Temp',checkOtpRequest.id);
        if(checkOtpRequest.id == undefined){
            res.json({
                message: "Invalid OTP",
                status: "failed",
            });
            return false;
        }
        
        var sendReedemRequest  = await User.sendReedemRequest(req.body);
        console.log('sendReedemRequest',sendReedemRequest);
        
        if(sendReedemRequest.insertId){
            req.body.redeem_request_id = 'REQ-'+sendReedemRequest.insertId
            req.body.redeem_id = sendReedemRequest.insertId
            
            var sendWalletPointsData = {
                customer_id: req.body.sfa_app_user_id ? req.body.sfa_app_user_id : 0,
                type: 'redeem_request',
                point : -req.body.gift_point,
                gift_id: req.body.gift_id ? req.body.gift_id : 0,
                offer_id: req.body.offer_id ? req.body.offer_id : 0,
                redeem_request_id: req.body.redeem_request_id ? req.body.redeem_request_id : 0,
                redeem_id: req.body.redeem_id ? req.body.redeem_id : 0
            }
            
            var sendWalletPoints = await User.sendWalletPoints(sendWalletPointsData);
            console.log('sendWalletPoints',sendWalletPoints);
            
            var updateRedeemRequestId  = await User.updateRedeemRequestId(req.body);
            console.log('updateRedeemRequestId',updateRedeemRequestId);
            await db.commit();
            res.status(200).json({
                message: "Request submitted",
                status: "success", 
            });
        }else{
            await db.commit();
            res.status(200).json({
                message: "Request not submitted",
                status: "success", 
            });
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.redeemRequestHistory = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        req.body.image_app_path = res.locals.image_app_path;
        var getRedeemRequestHistoryCount =  await User.getRedeemRequestHistoryCount(req.body);
        console.log('getRedeemRequestHistoryCount',getRedeemRequestHistoryCount);
        var getRedeemRequestHistoryListData = [];
        if(getRedeemRequestHistoryCount > 0){
            getRedeemRequestHistoryListData =  await User.getRedeemRequestHistoryListData(req.body);
            // console.log('getRedeemRequestHistoryListData',getRedeemRequestHistoryListData);
        }
        
           
        var getWalletPoints = await User.getWalletPoints(req.body);
        // console.log('getWalletPoints',getWalletPoints);

        var getLastBalanceUpdateData = await User.getLastBalanceUpdateData(req.body);
        // console.log('getLastBalanceUpdateData',getLastBalanceUpdateData);
        

        res.status(200).json({
            message: "Redeem Request List Data",
            status: "success",
            result : {
                data: getRedeemRequestHistoryListData,
                count : getRedeemRequestHistoryCount,
                walletPoints : getWalletPoints,
                walletLastUpdated : getLastBalanceUpdateData
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};
