const Notification = require('./../../models/app/notificationModel')
const { check, validationResult, matchedData, oneOf, body } = require('express-validator');
var db = require('../../config/db');


exports.getUserNotification = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        req.body.image_app_path = res.locals.image_app_path;
        if(req.body.appType == 'sfa'){
            var GP_getUserTodayNotification = await Notification.GP_getUserTodayNotification_salesUser(req.body);
            // console.log('GP_getUserTodayNotification',GP_getUserTodayNotification);
            var GP_getUserYesterdayNotification = await Notification.GP_getUserYesterdayNotification_salesUser(req.body);
            // console.log('GP_getUserYesterdayNotification',GP_getUserYesterdayNotification);        
            var GP_getUserNotification = await Notification.GP_getUserNotification_salesUser(req.body);
            // console.log('GP_getUserNotification',GP_getUserNotification);
            // var notificationRead = await Notification.notificationRead_salesUser(req.body);

        }else{
            var GP_getUserTodayNotification = await Notification.GP_getUserTodayNotification(req.body);
            // console.log('GP_getUserTodayNotification',GP_getUserTodayNotification);
            var GP_getUserYesterdayNotification = await Notification.GP_getUserYesterdayNotification(req.body);
            // console.log('GP_getUserYesterdayNotification',GP_getUserYesterdayNotification);        
            var GP_getUserNotification = await Notification.GP_getUserNotification(req.body);
            // console.log('GP_getUserNotification',GP_getUserNotification);
            // var notificationRead = await Notification.notificationRead(req.body);
        }
        var notificationIcon = await Notification.notificationIcon(req.body);
        
        await db.commit();
        res.status(200).json({
            message: "Notification Data",
            status: "success",
            data : {
                todayNotification : GP_getUserTodayNotification,
                yesterdayNotification : GP_getUserYesterdayNotification,
                earlierNotification : GP_getUserNotification,
                notificationIcon : notificationIcon
            }
        });
        
    }catch(e){
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
    
};


exports.getUnReadUserNotificationCount = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        if(req.body.appType == 'sfa'){
            var getUnReadUserNotificationCount = await Notification.getUnReadUserNotificationCount_salesUser(req.body);
            // console.log('getUnReadUserNotificationCount',getUnReadUserNotificationCount);
        }else{
            var getUnReadUserNotificationCount = await Notification.getUnReadUserNotificationCount(req.body);
            // console.log('getUnReadUserNotificationCount',getUnReadUserNotificationCount);
        }
        await db.commit();
        res.status(200).json({
            message: "Unread Notification Count",
            status: "success",
            data : {
                getUnReadUserNotificationCount : getUnReadUserNotificationCount,
            }
        });
        
    }catch(e){
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
    
};


exports.markReadNotification = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    

    try{

        if(req.body.appType == 'sfa'){
            var checkUserNotification = await Notification.checkUserNotification_salesUser(req.body);
            // console.log('checkUserNotification',checkUserNotification);
            if(checkUserNotification.length){
                var markReadNotification = await Notification.markReadNotification_salesUser(req.body);
                console.log('markReadNotification',markReadNotification);
            }
        }else{
            var checkUserNotification = await Notification.checkUserNotification(req.body);
            // console.log('checkUserNotification',checkUserNotification);
            if(checkUserNotification.length){
                var markReadNotification = await Notification.markReadNotification(req.body);
                console.log('markReadNotification',markReadNotification);
            }
        }

        await db.commit();
        res.status(200).json({
            message: "Notification Mark read",
            status: "success"
        });

    }catch(e){
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};

