const Cron = require("./../../models/web/cronModel");
const Notification = require("./../../models/web/notificationModel");
const { check, validationResult, matchedData, oneOf, body } = require('express-validator');
const https = require('https');
var path = require("path");
var db = require('../../config/db');
var moment = require('moment');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');
var NodeGeocoder = require('node-geocoder');

var options = {
    provider: 'google',
    // provider: 'openstreetmap',
    httpAdapter: 'https', // Default
    apiKey: 'AIzaSyDsNZsq0l-ioL87GPVYNsynX1k6GTfS-lE', // for Mapquest, OpenCage, Google Premier
    formatter: 'json' // 'gpx', 'string', ...
};



exports.updateUserLatLng = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        
        var getLastCheckinDetail = await Cron.getLastCheckinDetail(req.body);
        console.log('getLastCheckinDetail',getLastCheckinDetail);
        
        if(getLastCheckinDetail.length){
            var i = getLastCheckinDetail.length - 1;
            
            getLastCheckinDetail.forEach(async element => {
                console.log('element',element);
                var updateUserLatLng = await Cron.updateUserLatLng(element);
                console.log('updateUserLatLng',updateUserLatLng);
                
                if(i == 0){
                    await db.commit();
                    res.status(200).json({
                        message: "CRON executed",
                        status: "success"
                    });
                }
                
                i--;
            });
        }else{
            res.status(200).json({
                message: "CRON not executed",
                status: "success"
            });
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.startAttendanceRemainder = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
          var getSalesExecutiveData = await Cron.getSalesExecutiveData(req.body);
        console.log('getSalesExecutiveData',getSalesExecutiveData.length);
        
        if(getSalesExecutiveData.length){
            var i = getSalesExecutiveData.length - 1;
            
            getSalesExecutiveData.forEach(async element => {
                console.log('element',element);
                
                var title = 'Mark your Attendance';
                var remark = 'Don\'t forget to punch in today.';
                
                var sendNotificationDataBody = {
                    user_id: element.user_id ? element.user_id :0,
                    title: title ? title : '',
                    remark: remark ? remark : '',
                    notification_type: 'General'
                }
                
                var sendNotificationData =  await Notification.sendNotificationDataToUser(sendNotificationDataBody);
                // console.log('sendNotificationData',sendNotificationData);
                
                if(i == 0){
                    await db.commit();
                    res.status(200).json({
                        message: "CRON executed",
                        status: "success"
                    });
                }
                
                i--;
            });
        }else{
            res.status(200).json({
                message: "CRON not executed",
                status: "success"
            });
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.stopAttendanceRemainder = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        
        var getNotStoppedAttendance = await Cron.getNotStoppedAttendance(req.body);
        console.log('getNotStoppedAttendance',getNotStoppedAttendance.length);
        
        if(getNotStoppedAttendance.length){
            var i = getNotStoppedAttendance.length - 1;
            
            getNotStoppedAttendance.forEach(async element => {
                console.log('element',element);
                
                var title = 'STOP !!! Your attendance now.';
                var remark = 'Kindly stop your attendance.';
                
                var sendNotificationDataBody = {
                    user_id: element.user_id ? element.user_id :0,
                    title: title ? title : '',
                    remark: remark ? remark : '',
                    notification_type: 'General'
                }
                
                var sendNotificationData =  await Notification.sendNotificationDataToUser(sendNotificationDataBody);
                // console.log('sendNotificationData',sendNotificationData);
                
                if(i == 0){
                    await db.commit();
                    res.status(200).json({
                        message: "CRON executed",
                        status: "success"
                    });
                }
                
                i--;
            });
        }else{
            res.status(200).json({
                message: "CRON not executed",
                status: "success"
            });
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.updateLiveTrackingAddress = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        
        var getLiveTrackDataWithoutAddress = await Cron.getLiveTrackDataWithoutAddress(req.body);
        console.log('getLiveTrackDataWithoutAddress',getLiveTrackDataWithoutAddress.length);
        
        if(getLiveTrackDataWithoutAddress.length){
            var i = getLiveTrackDataWithoutAddress.length - 1;
            
            getLiveTrackDataWithoutAddress.forEach(async element => {
                console.log('element',element);
               
                var geocoder = NodeGeocoder(options);
                await geocoder.reverse({lat: element.lat, lon: element.lng}, function(err, res) {
                    // console.log('res ---->', res);
                    if(res.length){
                        element.address = res[0].formattedAddress
                    }
                });
                
                var updateAddressLiveTrack = await Cron.updateAddressLiveTrack(element);
                console.log('updateAddressLiveTrack',updateAddressLiveTrack);

                if(i == 0){
                    await db.commit();
                    res.status(200).json({
                        message: "CRON executed",
                        status: "success"
                    });
                }
                
                i--;
            });
        }else{
            res.status(200).json({
                message: "CRON not executed",
                status: "success"
            });
        }

    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.beatPlanRemainder = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        // console.log('body ==>', req.body);
        
        var getTodayAssignedBeatPlanData = await Cron.getTodayAssignedBeatPlanData(req.body);
        console.log('getTodayAssignedBeatPlanData',getTodayAssignedBeatPlanData);
        console.log('getTodayAssignedBeatPlanData',getTodayAssignedBeatPlanData.length);
        
        // return false;
        if(getTodayAssignedBeatPlanData.length){
            var i = getTodayAssignedBeatPlanData.length - 1;
            
            getTodayAssignedBeatPlanData.forEach(async element => {
                console.log('element',element);
                
                var title = 'Hey ' +element.user_name + ', Beat plan reminder!';
                var remark = 'Don\'t forget! Today store visit reminder for beat - '+ element.assigned_beat_name;
                
                var sendNotificationDataBody = {
                    user_id: element.user_id ? element.user_id :0,
                    title: title ? title : '',
                    remark: remark ? remark : '',
                    notification_type: 'General'
                }
                
                var sendNotificationData =  await Notification.sendNotificationDataToUser(sendNotificationDataBody);
                // console.log('sendNotificationData',sendNotificationData);
                
                if(i == 0){
                    await db.commit();
                    res.status(200).json({
                        message: "CRON executed",
                        status: "success"
                    });
                }
                
                i--;
            });
        }else{
            res.status(200).json({
                message: "CRON not executed",
                status: "success"
            });
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.updateLiveTrackingGoogleKm = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        // await db.beginTransaction();  
        // console.log('body ==>', req.body);

        var getLiveTrackUserData = await Cron.getLiveTrackUserData(req.body);
        console.log('getLiveTrackUserData',getLiveTrackUserData);
        
        if(getLiveTrackUserData.length){
            var i = getLiveTrackUserData.length - 1;
            
            getLiveTrackUserData.forEach(async element => {
                console.log('element',element);
                
                var getLiveTrackDataForGoogleKm = await Cron.getLiveTrackDataForGoogleKm(element);
                // console.log('getLiveTrackDataForGoogleKm',getLiveTrackDataForGoogleKm);
                console.log('getLiveTrackDataForGoogleKm',getLiveTrackDataForGoogleKm);
                if(getLiveTrackDataForGoogleKm.attendance_id){
                    var updateGoogleKmData = await Cron.updateGoogleKmData(getLiveTrackDataForGoogleKm);
                    console.log('updateGoogleKmData',updateGoogleKmData);
                }
           
                if(i == 0){
                    // await db.commit();
                    res.status(200).json({
                        message: "CRON executed",
                        status: "success"
                    });
                }
                
                i--;
            });
        }else{
            res.status(200).json({
                message: "CRON not executed",
                status: "success"
            });
        }
        
    } catch (e) {
        console.log('e', e);
        // await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};
