const Report = require("../../models/web/reportModel");
const { check, validationResult, matchedData, oneOf, body } = require('express-validator');
const https = require('https');
var path = require("path");
var db = require('../../config/db');
var moment = require('moment');
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


exports.getProductGroupWiseReport = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getProductGroupWiseReport =  await Report.getProductGroupWiseReport(req.body);
        // console.log('getProductGroupWiseReport',getProductGroupWiseReport);
        
        
        await db.commit();
        res.status(200).json({
            message: "Product group wise report",
            status: "success",
            result : {
                data : getProductGroupWiseReport,
            }
        });
        
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getStockReport = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getStockReportCount =  await Report.getStockReportCount(req.body);
        // console.log('getStockReportCount',getStockReportCount);
        var getStockReport = [];
        if(getStockReportCount > 0){
            getStockReport =  await Report.getStockReport(req.body);
            // console.log('getStockReport',getStockReport);
        }
        
        await db.commit();
        res.status(200).json({
            message: "Product stock report",
            status: "success",
            result : {
                data : getStockReport,
                totalCount : getStockReportCount
            }
        });
        
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.getGroupedStockReport = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getGroupedStockReportCount =  await Report.getGroupedStockReportCount(req.body);
        // console.log('getGroupedStockReportCount',getGroupedStockReportCount);
        var getGroupedStockReport = [];
        if(getGroupedStockReportCount > 0){
            getGroupedStockReport =  await Report.getGroupedStockReport(req.body);
            // console.log('getGroupedStockReport',getGroupedStockReport);
        }
        
        await db.commit();
        res.status(200).json({
            message: "Product grouped stock report",
            status: "success",
            result : {
                data : getGroupedStockReport,
                totalCount : getGroupedStockReportCount
            }
        });
        
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getSaleReport = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getSaleReport =  await Report.getSaleReport(req.body);
        // console.log('getSaleReport',getSaleReport);
        
        await db.commit();
        res.status(200).json({
            message: "Sale report",
            status: "success",
            result : {
                data : getSaleReport,
            }
        });
        
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getSalesExecutiveAnalyseReport = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getSalesExecutiveAnalyseReport =  await Report.getSalesExecutiveAnalyseReport(req.body);
        // console.log('getSalesExecutiveAnalyseReport',getSalesExecutiveAnalyseReport);
        
        await db.commit();
        res.status(200).json({
            message: "Sales Executive Analyse",
            status: "success",
            result : {
                data : getSalesExecutiveAnalyseReport,
            }
        });
        
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getDailyWorkingReport = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getDailyWorkingReport =  await Report.getDailyWorkingReport(req.body);
        // console.log('getDailyWorkingReport',getDailyWorkingReport);
        
        await db.commit();
        res.status(200).json({
            message: "Daily Working Report",
            status: "success",
            result : {
                data : getDailyWorkingReport,
            }
        });
        
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};