const User = require("./../../models/web/userModel");
const SFA_masterModel = require("./../../models/web/SFA_masterModel");
const Order = require("./../../models/web/orderModel");
const { check, validationResult, matchedData, oneOf, body } = require('express-validator');
const https = require('https');
var path = require("path");
var db = require('../../config/db');
var moment = require('moment');
const Network = require("./../../models/web/networkModel");
const { encrypt, decrypt, encrypter, my_simple_crypt } = require('../../config/common');


exports.login = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var loginData = await User.login(req.body);
        console.log('loginData',loginData);
        console.log('loginData',loginData.id);
        if(loginData.id == undefined){
            res.json({
                message: "Invalid Login",
                status: "failed",
            });
            return false;
        }else{
            var updateSessionToken =  await User.updateSessionToken(loginData);
            console.log('updateSessionToken',updateSessionToken);
            if(updateSessionToken.affectedRows){
                
                loginData.session_token = updateSessionToken.session_token;
                var getSystemUserPermissionDetail = await User.getSystemUserPermissionDetail({user_id : loginData.id});
                // console.log('getSystemUserPermissionDetail',JSON.stringify(getSystemUserPermissionDetail));
                var drModule = [];
                // var drModule = getSystemUserPermissionDetail.length ? getSystemUserPermissionDetail.filter(x=>x.module_id == 2)[0].dropDown : []; 
                // console.log('drModule',drModule);
                // var i = drModule.length - 1;
                if(drModule.length && 1 == 2){
                    drModule.forEach(async element => {
                        // if(element.module_id == 3 || element.module_id == 4){
                        //     element.count = 0;
                        //     element.count = await Network.getNetworkCount({filter:{
                        //         cust_type_id : element.name == 'Distributor' ? '1' : '2',
                        //         status : 1,
                        //         deleted : 0
                        //     }})
                        //     console.log('i',i);
                        //     if(i == 0){
                        //         await db.commit();
                        //         res.json({
                        //             message: "Login Successfully",
                        //             status: "success",
                        //             data :{
                        //                 userData : loginData,
                        //                 permissionData : getSystemUserPermissionDetail,
                        //                 redirectUrl : getSystemUserPermissionDetail.redirectUrl
                        //             }
                        //         });
                        //     }
                        //     i--;
                        //     // console.log('element',element);
                        // }
                    });
                }else{
                    await db.commit();
                    res.json({
                        message: "Login Successfully",
                        status: "success",
                        data :{
                            userData : loginData,
                            permissionData : getSystemUserPermissionDetail,
                            redirectUrl : getSystemUserPermissionDetail.redirectUrl
                        }
                    });
                }
                
                
            }else{
                await db.rollback();
                res.json({
                    message: "Error occured",
                    status: "failed",
                });
            }
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.leftNavigationMenu = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        
        var getSystemUserPermissionDetail = await User.getSystemUserPermissionDetail({user_id : req.body.sfa_web_user_id});
        // console.log('getSystemUserPermissionDetail',getSystemUserPermissionDetail);
        // console.log('getSystemUserPermissionDetail',getSystemUserPermissionDetail.length);
        
        // return false;

        res.json({
            message: "Left Navigation",
            status: "success",
            data :{
                permissionData : getSystemUserPermissionDetail,
            }
        });
        
    } catch (e) {
        console.log('e', e);
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.logout = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var logoutUser = await User.logoutUser(req.body);
        console.log('logoutUser',logoutUser);
        if(logoutUser.affectedRows){
            await db.commit();
            res.json({
                message: "Logout Successfully",
                status: "success"
            });  
        }
        
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getModuleList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getModuleList =  await User.getModuleList(req.body);
        // console.log('getModuleList',getModuleList);
        
        res.status(200).json({
            message: "Module List",
            status: "success",
            result : {
                data: getModuleList,
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};




exports.getSystemUserList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        req.body.filter.for_system_user = 1;
        
        var getSystemUserCount = await User.getSystemUserCount(req.body)
        
        var getSystemUserList = [];
        if(getSystemUserCount > 0){
            getSystemUserList =  await User.getSystemUserList(req.body);
            // console.log('getSystemUserList',getSystemUserList);
        }
        
        res.status(200).json({
            message: "System User List",
            status: "success",
            result : {
                data: getSystemUserList,
                totalCount : getSystemUserCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.addSystemUserData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var addSystemUserData = await User.addSystemUserData(req.body);
        // console.log('addSystemUserData',addSystemUserData);
        
        if(addSystemUserData.insertId){
            req.body.user_id = addSystemUserData.insertId ? addSystemUserData.insertId : 0
            var addSystemUserPermissionData = await User.addSystemUserPermissionData(req.body);
            console.log('addSystemUserPermissionData',addSystemUserPermissionData);
            await db.commit();
            res.status(200).json({
                message: "System User Added",
                status: "success",
            });
        }else{
            await db.rollback();
            res.status(200).json({
                message: "System User not Added",
                status: "failed",
            });
        }
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        var errMessage = 'Error Occured';
        if(e.code == 'ER_DUP_ENTRY'){
            var sqlMessage = e.sqlMessage.replace(/'/, "")
            const myArray = sqlMessage.split("for key ");
            console.log('myArray ==>',myArray[1])
            var key = myArray[1];
            console.log('key',key);
            key = key.replace(/'/g, "");
            console.log('key',key);
            if(key == 'tg_system_users.tg_system_users_UN'){
                errMessage = 'Duplicate entry for mobile number - '+req.body.mobile_no;
            }else if(key == 'tg_system_users.tg_system_users_email_UN'){
                errMessage = 'Duplicate entry for email - '+req.body.email;
            }else if(key == 'tg_system_users.tg_system_users_mobile_1_UN'){
                errMessage = 'Duplicate entry for mobile number 1  - '+req.body.mobile_no_1;
            }else if(key == 'tg_system_users.tg_system_users_code_UN'){
                errMessage = 'Duplicate entry for employee code  - '+req.body.emp_code;
            }else{
                errMessage = 'Error Occured';
            }
        }
        console.log('errMessage',errMessage);
        res.status(200).json({
            message: errMessage,
            status: "error",
            err : err
        });
        return false;
    }
};


exports.updateSystemUserData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var updateSystemUserData = await User.updateSystemUserData(req.body);
        // console.log('updateSystemUserData',updateSystemUserData);
        
        if(updateSystemUserData.affectedRows){
            
            var deleteSystemUserPermissionData = await User.deleteSystemUserPermissionData(req.body);
            console.log('deleteSystemUserPermissionData',deleteSystemUserPermissionData);
            
            var addSystemUserPermissionData = await User.addSystemUserPermissionData(req.body);
            console.log('addSystemUserPermissionData',addSystemUserPermissionData);

            await db.commit();
            res.status(200).json({
                message: "System User Updated",
                status: "success",
            });
            
        }else{
            await db.rollback();
            res.status(200).json({
                message: "System User not Updated",
                status: "failed",
            });
        }
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        var errMessage = 'Error Occured';
        if(e.code == 'ER_DUP_ENTRY'){
            var sqlMessage = e.sqlMessage.replace(/'/, "")
            const myArray = sqlMessage.split("for key ");
            console.log('myArray ==>',myArray[1])
            var key = myArray[1];
            console.log('key',key);
            key = key.replace(/'/g, "");
            console.log('key',key);
            if(key == 'tg_system_users.tg_system_users_UN'){
                errMessage = 'Duplicate entry for mobile number - '+req.body.mobile_no;
            }else if(key == 'tg_system_users.tg_system_users_email_UN'){
                errMessage = 'Duplicate entry for email - '+req.body.email;
            }else if(key == 'tg_system_users.tg_system_users_mobile_1_UN'){
                errMessage = 'Duplicate entry for mobile number 1  - '+req.body.mobile_no_1;
            }else if(key == 'tg_system_users.tg_system_users_code_UN'){
                errMessage = 'Duplicate entry for employee code  - '+req.body.emp_code;
            }else{
                errMessage = 'Error Occured';
            }
        }
        console.log('errMessage',errMessage);
        res.status(200).json({
            message: errMessage,
            status: "error",
            err : err
        });
        return false;
    }
};



exports.deleteSystemUserData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var deleteSystemUserData = await User.deleteSystemUserData(req.body);
        // console.log('deleteSystemUserData',deleteSystemUserData);
        
        if(deleteSystemUserData.affectedRows){
            await db.commit();
            res.status(200).json({
                message: "System User Updated",
                status: "success",
            });
        }else{
            await db.rollback();
            res.status(200).json({
                message: "System User not Updated",
                status: "failed",
            });
        }
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.updateSystemUserPermissionData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var updateSystemUserPermissionData = await User.updateSystemUserPermissionData(req.body);
        // console.log('updateSystemUserPermissionData',updateSystemUserPermissionData);
        
        if(updateSystemUserPermissionData.affectedRows){
            
            await db.commit();
            res.status(200).json({
                message: "System User Permissions Updated",
                status: "success",
            });
        }else{
            await db.rollback();
            res.status(200).json({
                message: "System User Permissions not Updated",
                status: "failed",
            });
        }
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getSystemUserDetail = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        req.body.user_id = decrypt(req.body.user_id);
        
        var getSystemUserDetail = await User.getSystemUserDetail(req.body);
        // console.log('getSystemUserDetail',getSystemUserDetail);
        
        var getSystemUserPermissionDetail = await User.getSystemUserPermissionDetail(req.body);
        // console.log('getSystemUserPermissionDetail',getSystemUserPermissionDetail);
        
        if(getSystemUserDetail.id != undefined){
            res.status(200).json({
                message: "User detail",
                status: "success",
                data : {
                    detail : getSystemUserDetail,
                    permissionData : getSystemUserPermissionDetail
                }
            });
        }else{
            res.status(200).json({
                message: "User detail",
                status: "notfound",
            });
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.getTempRegisterdata = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        var getTempRegisterCount = await User.getTempRegisterCount(req.body)
        
        var getTempRegisterListData = [];
        if(getTempRegisterCount > 0){
            getTempRegisterListData =  await User.getTempRegisterListData(req.body);
            // console.log('getTempRegisterListData',getTempRegisterListData);
        }
        
        res.status(200).json({
            message: "Temp Register List",
            status: "success",
            result : {
                data: getTempRegisterListData,
                totalCount : getTempRegisterCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



// sales user code start

exports.addSalesUserData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var addSalesUserData = await User.addSalesUserData(req.body);
        // console.log('addSalesUserData',addSalesUserData);
        
        if(addSalesUserData.insertId){
            req.body.user_id = addSalesUserData.insertId ? addSalesUserData.insertId : 0
            
            // if(req.body.rmData?.id){
            //     var salesUserAssign = await User.salesUserAssign(req.body);
            //     console.log('salesUserAssign',salesUserAssign);
            // }
            console.log(req.body);
            // if(req.body.beat?.length){
            //     var i = req.body.beat.length - 1;
            //     req.body.beat.forEach(async x =>{
            //         var salesUserAssignBeat = await User.salesUserAssignBeat({'beat' : x, 'user_id' : addSalesUserData.insertId ? addSalesUserData.insertId : 0});
            //         console.log('salesUserAssignBeat',salesUserAssignBeat);
                    
            //         if(i == 0){
            //             return;
            //         }
            //         i--;
            //     })
            // }

            // if(req.body.product_division?.length){
            //     var j = req.body.product_division.length - 1;
            //     req.body.product_division.forEach(async x =>{
            //         var salesUserAssignProductDivision = await User.salesUserAssignProductDivision({'product_division' : x, 'user_id' : addSalesUserData.insertId ? addSalesUserData.insertId : 0});
            //         console.log('salesUserAssignProductDivision',salesUserAssignProductDivision);
                    
            //         if(j == 0){
            //             return;
            //         }
            //         j--;
            //     })
            // }
            
            if(req.body.working_state?.length){
                var i = req.body.working_state.length - 1;
                req.body.working_state.forEach(async x =>{
                    var salesUserAssignState = await User.salesUserAssignState({'state_name' : x, 'user_id' : addSalesUserData.insertId ? addSalesUserData.insertId : 0});
                    console.log('salesUserAssignState',salesUserAssignState);
                    
                    if(i == 0){
                        await db.commit();
                        res.status(200).json({
                            message: "Sales User Added",
                            status: "success",
                        });
                    }
                    i--;
                })
            }else{
                await db.commit();
                res.status(200).json({
                    message: "Sales User Added",
                    status: "success",
                });
            }   
        }else{
            await db.rollback();
            res.status(200).json({
                message: "Sales User not Added",
                status: "failed",
            });
        }
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        var errMessage = 'Error Occured';
        if(e.code == 'ER_DUP_ENTRY'){
            var sqlMessage = e.sqlMessage.replace(/'/, "")
            const myArray = sqlMessage.split("for key ");
            console.log('myArray ==>',myArray[1])
            var key = myArray[1];
            console.log('key',key);
            key = key.replace(/'/g, "");
            console.log('key',key);
            if(key == 'tg_system_users_UN'){
                errMessage = 'Duplicate entry for mobile number - '+req.body.mobile;
            }else if(key == 'tg_system_users_email_UN'){
                errMessage = 'Duplicate entry for email - '+req.body.email;
            }else if(key == 'tg_system_users_mobile_1_UN'){
                errMessage = 'Duplicate entry for mobile number 1  - '+req.body.mobile_no_1;
            }else if(key == 'tg_system_users_code_UN'){
                errMessage = 'Duplicate entry for employee code  - '+req.body.emp_code;
            }else{
                errMessage = 'Error Occured';
            }
        }
        console.log('errMessage',errMessage);
        res.status(200).json({
            message: errMessage,
            status: "error",
            err : err
        });
        return false;
    }
};



exports.getSalesUserList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        req.body.limit = 100000;
        req.body.start = 0;
        
        
        req.body.filter.for_sales_user = 1;
        
        var getSystemUserCount = await User.getSystemUserCount(req.body)
        
        var getSystemUserList = [];
        if(getSystemUserCount > 0){
            getSystemUserList =  await User.getSystemUserList(req.body);
            // console.log('getSystemUserList',getSystemUserList);
        }
        
        res.status(200).json({
            message: "User List",
            status: "success",
            result : {
                data: getSystemUserList,
                totalCount : getSystemUserCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};

exports.getSalesUserListExcel = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        req.body.limit = 100000;
        req.body.start = 0;
        
        
        req.body.filter.for_sales_user = 1;

           var getSalesUserList =  await User.getSystemUserList(req.body);
            // console.log('getSystemUserList',getSystemUserList);
            var getSalesUserListExcel = [];
            if(getSalesUserList.length){
                var i = getSalesUserList.length - 1;
            var file_name = 'Sales-User-Data';

            getSalesUserList.forEach(async (element, index) => {
                
                var data = {
                    'S.No.': index + 1,
                    'Date Created': element.created_on ? moment(element.created_on).format('YYYY-MM-DD') : '0000-00-00',
                    'Designation': element.designation ? element.designation : '',
                    'Name' : element.name ? element.name : '',
                    'Mobile No': element.mobile_no ? element.mobile_no : '',
                    'Emp Code': element.emp_code ? element.emp_code : '',
                    'Weekly off': element.weekely_off ? element.weekely_off : '',
                    'Date Of Joining': element.date_of_joining ? moment(element.date_of_joining).format('YYYY-MM-DD') : '0000-00-00',
                    'Wallet Points' : element.wallet_points ? element.wallet_points :0,
                    'Status' : element.status == 1 ? 'Active' : 'Inactive'
                    
                };
                getSalesUserListExcel.push(data);
                
                if (i == 0) {
                    res.status(200).json({
                        message: "Product List Excel",
                        status: "success",
                        result: {
                            data: getSalesUserListExcel,
                            file_name: file_name
                        }
                    });
                }
                
                i--;
                

            });
        }else{
            res.status(200).json({
                message: "Sales User List",
                status: "success",
                result : {
                    data: getSystemUserList,
                    
                }
                
            });

        }
            

            
            
        
        
      
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.getSalesUserDetail = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        req.body.image_app_path = res.locals.image_app_path;
        
        req.body.user_id = decrypt(req.body.user_id);
        
        var getSalesUserDetail = await User.getSalesUserDetail(req.body);
        // console.log('getSalesUserDetail',getSalesUserDetail);
        
        var getSalesUserAssignedUser = await User.getSalesUserAssignedUser(req.body);
        // console.log('getSalesUserAssignedUser',getSalesUserAssignedUser);
        
        var getSalesUserReportingUser = await User.getSalesUserReportingUser(req.body);
        // console.log('getSalesUserReportingUser',getSalesUserReportingUser);

        var getSalesUserAssignedState = await User.getSalesUserAssignedState(req.body);
        // console.log('getSalesUserAssignedState',getSalesUserAssignedState);

        var getSalesUserAssignedProductDivision = await User.getSalesUserAssignedProductDivision(req.body);
        // console.log('getSalesUserAssignedProductDivision',getSalesUserAssignedProductDivision);
        
        var counterData = {
            // checkinCount : await SFA_masterModel.getCheckinDataCount({'filter' : {'user_id' : req.body.user_id}}),
            // followupCount :  await SFA_masterModel.getFollowupDataCount({'filter' : {'user_id' : req.body.user_id}}),
            // expenseCount : await SFA_masterModel.getExpenseDataCount({'filter' : {'user_id' : req.body.user_id}}),
            // leaveCount : await SFA_masterModel.getLeaveDataCount({'filter' : {'user_id' : req.body.user_id}}),
            // primaryOrderCount : await Order.getOrderCount({'filter' : {'user_id' : req.body.user_id, 'order_type' : 'Primary'}}),
            // secondaryOrderCount : await Order.getOrderCount({'filter' : {'user_id' : req.body.user_id, 'order_type' : 'Secondary'}}),
            retailerCount : await Network.getNetworkCount({'filter' : {cust_type_id : 10}}),
            distributorCount : 0
        };
        
        
        if(getSalesUserDetail.id != undefined){
            res.status(200).json({
                message: "Sales User detail",
                status: "success",
                data : {
                    detail : getSalesUserDetail,
                    assignedUser : getSalesUserAssignedUser,
                    reportingUser : getSalesUserReportingUser,
                    assignedState : getSalesUserAssignedState,
                    assignedProductDivision : getSalesUserAssignedProductDivision,
                    counterData : counterData
                }
            });
        }else{
            res.status(200).json({
                message: "User detail",
                status: "notfound",
            });
        }
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};



exports.updateSalesUserData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var updateSalesUserData = await User.updateSalesUserData(req.body);
        // console.log('updateSalesUserData',updateSalesUserData);
        
        if(updateSalesUserData.affectedRows){
            // var deleteSalesUserAssign = await User.deleteSalesUserAssign(req.body);
            // console.log('deleteSalesUserAssign',deleteSalesUserAssign);
            
            // if(req.body.rmData?.id){
            //     var salesUserAssign = await User.salesUserAssign(req.body);
            //     console.log('salesUserAssign',salesUserAssign);
            // }
            
            // if(req.body.beat?.length){
            //     var i = req.body.beat.length - 1;
            //     var deleteSalesUserAssignBeat = await User.deleteSalesUserAssignBeat(req.body);
            //     console.log('deleteSalesUserAssignBeat',deleteSalesUserAssignBeat);
            //     req.body.beat.forEach(async x =>{
            //         var salesUserAssignBeat = await User.salesUserAssignBeat({'beat' : x, 'user_id' : req.body.id});
            //         console.log('salesUserAssignBeat',salesUserAssignBeat);
                    
            //         if(i == 0){
            //             return;
            //         }
            //         i--;
            //     })
            // }
            

            // if(req.body.product_division?.length){
            //     var j = req.body.product_division.length - 1;
            //     var deleteSalesUserAssignProductDivision = await User.deleteSalesUserAssignProductDivision(req.body);
            //     console.log('deleteSalesUserAssignProductDivision',deleteSalesUserAssignProductDivision);
            //     req.body.product_division.forEach(async x =>{

            //         var salesUserAssignProductDivision = await User.salesUserAssignProductDivision({'product_division' : x, 'user_id' : req.body.id});
            //         console.log('salesUserAssignProductDivision',salesUserAssignProductDivision);
                    
            //         if(j == 0){
            //             return;
            //         }
            //         j--;
            //     })
            // }
            

            if(req.body.working_state?.length){
                var i = req.body.working_state.length - 1;
                var deleteSalesUserAssignState = await User.deleteSalesUserAssignState(req.body);
                console.log('deleteSalesUserAssignState',deleteSalesUserAssignState);
                req.body.working_state.forEach(async x =>{
                    var salesUserAssignState = await User.salesUserAssignState({'state_name' : x, 'user_id' : req.body.id});
                    console.log('salesUserAssignState',salesUserAssignState);
                    
                    if(i == 0){
                        await db.commit();
                        res.status(200).json({
                            message: "Sales User Updated",
                            status: "success",
                        });
                    }
                    i--;
                })
            }else{
                await db.commit();
                res.status(200).json({
                    message: "Sales User Updated",
                    status: "success",
                });
            }
            
        }else{
            await db.rollback();
            res.status(200).json({
                message: "Sales User not Updated",
                status: "failed",
            });
        }
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        var errMessage = 'Error Occured';
        if(e.code == 'ER_DUP_ENTRY'){
            var sqlMessage = e.sqlMessage.replace(/'/, "")
            const myArray = sqlMessage.split("for key ");
            console.log('myArray ==>',myArray[1])
            var key = myArray[1];
            console.log('key',key);
            key = key.replace(/'/g, "");
            console.log('key',key);
            if(key == 'tg_system_users_UN'){
                errMessage = 'Duplicate entry for mobile number - '+req.body.mobile_no;
            }else if(key == 'tg_system_users_email_UN'){
                errMessage = 'Duplicate entry for email - '+req.body.email;
            }else if(key == 'tg_system_users_mobile_1_UN'){
                errMessage = 'Duplicate entry for mobile number 1  - '+req.body.mobile_no_1;
            }else if(key == 'tg_system_users_code_UN'){
                errMessage = 'Duplicate entry for employee code  - '+req.body.emp_code;
            }else{
                errMessage = 'Error Occured';
            }
        }
        console.log('errMessage',errMessage);
        res.status(200).json({
            message: errMessage,
            status: "error",
            err : err
        });
        return false;
    }
};



// sales user code end


exports.getAllowanceDataList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        req.body.filter.for_sales_user = 1;
        
        var getAllowanceUserDataCount = await User.getAllowanceUserDataCount(req.body)
        
        var getAllowanceUserDataList = [];
        if(getAllowanceUserDataCount > 0){
            getAllowanceUserDataList =  await User.getAllowanceUserDataList(req.body);
            // console.log('getAllowanceUserDataList',getAllowanceUserDataList);
        }
        
        res.status(200).json({
            message: "Allowance User Data List",
            status: "success",
            result : {
                data: getAllowanceUserDataList,
                totalCount : getAllowanceUserDataCount
            }
            
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};


exports.updateUserAllowanceData = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
        
        var getUserAllowanceData = await User.getUserAllowanceData(req.body);
        console.log('getUserAllowanceData',getUserAllowanceData);
        
        if(getUserAllowanceData.id){
            var updateUserAllowanceData = await User.updateUserAllowanceData(req.body);
            console.log('updateUserAllowanceData',updateUserAllowanceData);
        }else{
            var insertUserAllowanceData = await User.insertUserAllowanceData(req.body);
            console.log('insertUserAllowanceData',insertUserAllowanceData);
        }
        
        await db.commit();
        res.status(200).json({
            message: "Allowance User Data updated",
            status: "success"
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};




exports.trackUserList = async function (req, res) {
    
    const errors = validationResult(req);
    if (!errors.isEmpty()) {
        const x = matchedData(req);
        return res.send({ message: 'Invalid Values', status: 'invalid', err: errors.mapped() });
    }
    
    try {
        await db.beginTransaction();  
   
        var getAttendanceUserDataListCount = await SFA_masterModel.getAttendanceUserDataListCount(req.body);

        var getAttendanceUserDataList =  await SFA_masterModel.getAttendanceUserDataList(req.body);
     
        res.status(200).json({
            message: "Attendance User List",
            status: "success",
            result : {
                data: getAttendanceUserDataList,
                totalCount : getAttendanceUserDataListCount
            }
        });
        
    } catch (e) {
        console.log('e', e);
        await db.rollback()
        var err = {
            code: e.code,
            sqlMessage: e.sqlMessage
        };
        res.status(200).json({
            message: "Error Occured",
            status: "error",
            err :err
        });
        return false;
    }
};
